/* This code is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
   
   This code is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   Code by Pedro Jos Ramrez Gutirrez */



#include "delayms.h"

#define INOP __asm__ __volatile__ ("nop")
#define RETRASO_RESTO_CICLOS INOP


#if (PIC_FREC == 20000000) || (PIC_FREC == 4000000) || (PIC_FREC == 1000000)

/* Valores ajustados para optimizacion -Os en la version 4.0.2 de GCC */

#define CICLOS_BUCLE 25
#define CICLOS_INICIO_CUENTA 241/CICLOS_BUCLE
void delayms(unsigned int a){
	unsigned long b;
	if (a == 0) return;
	b = ((PIC_FREC / 4000)/CICLOS_BUCLE) * (unsigned long)a;
	b = b - CICLOS_INICIO_CUENTA;
	while(b!=0){
		RETRASO_RESTO_CICLOS;
		b = b - 1;
	}
}

#else /* PIC_FREC no estandar */ 

/* Valores ajustados para optimizacion -Os en la version 4.0.2 de GCC */

#define CICLOS_BUCLE 35
#define CICLOS_INICIO_CUENTA (1892 - 1)
void delaymsxxM(unsigned long frecuencia, unsigned int a){
	long b;
	if (a == 0) return;
	b = (frecuencia / 4000) * (unsigned long)a;
	b = b - CICLOS_INICIO_CUENTA;
	while(b>0){
		RETRASO_RESTO_CICLOS;
		b = b - CICLOS_BUCLE;
	}
}
#endif

